package org.ids_mannheim;

import java.util.function.Consumer;
import org.apache.commons.collections4.queue.CircularFifoQueue;

public class SlidingWindowQueue extends  CircularFifoQueue {
    private final int maxSize;
    private final Consumer<String> flush;

    public SlidingWindowQueue(int size, Consumer<String> flush) {
        super(size);
        this.maxSize = size;
        this.flush = flush;
    }

    public boolean add(String k) {
        boolean r = super.add(k);
        if (isAtFullCapacity()) {
            this.flush.accept(String.join(" ", this));
        }
        return r;
    }
}
